// obecna funkcia, zobrazi v hlavnom okne browseru danu URL
function showInMainframe(url, newTab) {
	if (newTab) {
        var newTab = window.top.getBrowser().addTab(url);
        window.top.getBrowser().selectedTab = newTab;
		return true;
	}
	if (url) {
		window._content.location = url;
		return true;
	}
	return false;
}

// obecna funkcia na odoslanie emailu (defaultne sa odosiela na adresu autora projektu)
function sendMail(subject, address) {
	var defaultAddress = "mail@martincohen.info";
	var address = (address) ? address : defaultAddress;
	if (subject) {
		document.location = "mailto:" + address + "?subject=deafbar (" + subject + ")";
		return true;
	}
	return false;
}

// obecna funkcia na otvorenie popupu
function openPopup(url, name, width, height) {
	if (url) {
		width = (!isNaN(width)) ? width : 400;
		height = (!isNaN(height)) ? height : 400;
		var popup = window.open(url, name, "width=" + width + ", height=" + height + ", chrome, centerscreen, resizable");
		// TODO: hodil by sa focus a sizeToContent pri onloade
		return popup;
	}
	return false;
}

// obecna funkcia pre zjednodusenie zapisu pri priradovani hodnoty stlpca nejakemu inemu elementu
function setValByCol(field, treeElm, column) {
	// TODO: osetrit vstupy, osetrit ci existuje currentIndex, atd.
	var fieldElm = document.getElementById(field);
	var colValue = treeElm.contentView.getCellText(treeElm.currentIndex, treeElm.columns.getNamedColumn(column));
	fieldElm.value = colValue;
	return true;
}


function rnd() {
	return Math.round(Math.random() * 10000);
}


function updateTree(tree, dataSources, ref) {
	if(tree) {
		if(dataSources) {
			tree.originalDataSources = dataSources;
		} else if(!tree.originalDataSources) {
			tree.originalDataSources = tree.getAttribute('datasources');
		}
		tree.setAttribute('datasources', '');
		tree.setAttribute('datasources', tree.originalDataSources + '?' + rnd());
		if(ref) {
			tree.setAttribute('ref', ref);
		}
		if(tree.builder) {
			tree.builder.rebuild();
		}
	}
}

function changeTabTo(tabId, toId) {
	elm = document.getElementById(tabId);
	panels = elm.getElementsByTagName('tabpanels')[0];
	panels.selectedPanel = document.getElementById(toId);
}

function changeTab(menuList, tabId) {
	var item = menuList.selectedItem;
	changeTabTo(tabId, item.id.substr(5));
}

function gotoLink(tree, linkId, newTab) {
	var treeElm = tree;
	if (treeElm.currentIndex > -1) {
		var url = treeElm.contentView.getCellText(treeElm.currentIndex, treeElm.columns.getNamedColumn(linkId));
		//alert(url);
		return showInMainframe(url, newTab);
	}
	return false;
}

function putValToClipboard(treeElm, colId) {
	prompt('Entity', treeElm.contentView.getCellText(treeElm.currentIndex, treeElm.columns.getNamedColumn(colId)));
/*
  const gClipboardHelper = Components.classes["@mozilla.org/widget/clipboardhelper;1"]
    .getService(Components.interfaces.nsIClipboardHelper);
  gClipboardHelper.copyString(treeElm.contentView.getCellText(treeElm.currentIndex, colId));
*/
}

function changeSourceTo(treeId, ref, source) {
	//alert(ref + " .. " + source);
	updateTree(document.getElementById(treeId), source, ref);
}
